// ----------------------------------------------------------------------------
//
//  Copyright (C) 2021 Arthur Benilov <arthur.benilov@gmail.com>
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ----------------------------------------------------------------------------

#pragma once

#include "aeolus/globals.h"

#include <vector>

class AeolusAudioProcessor;

struct Parameters
{
    AeolusAudioProcessor& processor;

    juce::AudioParameterFloat* reverbWet;
    juce::AudioParameterFloat* volume;

    std::vector<juce::AudioParameterFloat*> divisionsGain;

    Parameters(AeolusAudioProcessor& proc);

    juce::var toVar() const;
    void fromVar(const juce::var& v);
};
